library GDIHookHandler;

uses
{$ifdef debug}
sysutils,
{$endif}
  Storage,
  logging,
  windows,
  GDIHookMessages in 'GDIHookMessages.pas';
type PAttachToWindowStruct=^TAttachToWindowStruct;
TAttachToWindowStruct=packed record
LibPath:PWideChar;
LibPathLength:cardinal;
Hook:HHOOK;
end;
function HookProc(nCode, wParam, lParam: integer): integer; stdcall;
var cwp:PCWPStruct;
ProcessHandle:THandle;
ATWStruct:PAttachToWindowStruct;
BytesRead:DWORD;
p:pointer;
begin
ATWStruct:=nil;
cwp:=pointer(lparam);
if (ncode = hc_action) and (cwp.message = GDIHook_WM_Attach) then
if (getmodulehandle('gdihook.dll') = 0) then begin
processHandle:=OpenProcess(Process_VM_Read, false, cwp.wParam);
if processHandle=0 then
log('HookProc: OpenProcess failed');
new(ATWStruct);
if not ReadProcessMemory(processHandle, pointer(cwp.lparam), ATWStruct, sizeof(TAttachToWindowStruct),
BytesRead) then
log('HookProc: ReadProcessMemory failed');
getmem(p, ATWStruct^.LibPathLength);
if not ReadProcessMemory(processHandle, ATWStruct.LibPath, p,
ATWStruct^.LibPathLength, BytesRead) then
log('HookProc: ReadProcessMemory failed');
if LoadLibraryW(p)= 0 then
log('HookProc: LoadLibrary failed');
freemem(p, ATWStruct^.LibPathLength);
CloseHandle(processHandle);
end;
if (ncode = hc_action) and (cwp.message = GDIHook_WM_Detach) then
begin
processHandle:=OpenProcess(Process_VM_Read, false, cwp.wParam);
if processHandle=0 then
log('HookProc: OpenProcess failed');
new(ATWStruct);
if not ReadProcessMemory(processHandle, pointer(cwp.lparam), ATWStruct,
sizeof(TAttachToWindowStruct), BytesRead) then
log('HookProc: ReadProcessMemory failed');
freelibrary(GetModuleHandle('gdihook.dll'));
CloseHandle(processHandle);
end;
if ATWStruct<> nil then begin
     Result:=CallNextHookEx(ATWStruct^.Hook, nCode, wParam, lParam);
dispose(ATWStruct);
end else
     Result:=CallNextHookEx(0, nCode, wParam, lParam);
end;

function AttachToWindow(const handle:THandle; var LibName:WideChar):boolean; stdcall;
var ATWStruct:PAttachToWindowStruct;
hwnd:THandle;
begin
result:=false;
new(ATWStruct);
ATWStruct^.LibPath := @libname;
ATWStruct^.LibPathLength := LStrLenW(@Libname) *2 +2;
hwnd:=GetAncestor(handle, GA_ROOTOWNER);
ATWStruct^.Hook:=SetWindowsHookEx(WH_CALLWNDPROC, @hookproc, getmodulehandle('gdihookhandler.dll'), GetWindowThreadProcessID(hwnd, nil));
if ATWStruct^.Hook=0 then begin
log('AttachToWindow: SetWindowsHookEx failed');
exit;
end;
sendmessage(hwnd, GDIHook_WM_Attach, GetCurrentProcessID(), lparam(ATWStruct));
UnhookWindowsHookEx(ATWStruct^.Hook);
dispose(ATWStruct);
result:=true;
end;

Function DetachFromWindow(handle:THandle):Boolean; stdcall;
var ATWStruct:PAttachToWindowStruct;
hwnd:THandle;
begin
result:=false;
new(ATWStruct);
hwnd:=GetAncestor(handle, GA_ROOTOWNER);
ATWStruct^.Hook:=SetWindowsHookEx(WH_CALLWNDPROC, @hookproc, getmodulehandle('gdihookhandler.dll'), GetWindowThreadProcessID(hwnd, nil));
if ATWStruct^.Hook=0 then begin
log('DetachFromWindow: SetWindowsHookEx failed');
exit;
end;
sendmessage(hwnd, GDIHook_WM_Detach, GetCurrentProcessID(), LParam(ATWStruct));
UnhookWindowsHookEx(ATWStruct^.Hook);
dispose(ATWStruct);
result:=true;
end;

  procedure DLLEntryPoint(Reason: Integer);
var temppath:PWideChar;
 begin
case Reason of
DLL_PROCESS_ATTACH: begin
getmem(TempPath, max_path *2 +2);
GetTempPathW(max_path, temppath);
startlog(widechartostring(temppath)+ 'gdihook.log');
freemem(temppath, max_path *2 +2);
RegisterMessages;
end;
DLL_PROCESS_DETACH: CloseStorage;
end;
end;

exports AttachToWindow, DetachFromWindow, GetTextAtCoords, GetTextInRect, GetTextFromWindow, ClearStorageInRect;
begin
DLLProc := @DLLEntryPoint;
                                  DLLEntryPoint(DLL_PROCESS_ATTACH);
end.
