unit HookedFunctions;

interface
Function HookFunctions:boolean;
Procedure UnhookFunctions;

implementation
uses windows, storage, InterceptAPI;
var
TrueBeginPaint:function(hWnd: HWND; var lpPaint: TPaintStruct): HDC; stdcall;
TrueTextOutA:Function(DC: HDC; X, Y: Integer; Str: PAnsiChar; Count: Integer): BOOL; stdcall;
TrueTextOutW:function(DC: HDC; X, Y: Integer; Str: PWideChar; Count: Integer): BOOL; stdcall;
TrueExtTextOutA:function(DC: HDC; X, Y: Integer; Options: Longint;
  Rect: PRect; Str: PAnsiChar; Count: Longint; Dx: PInteger): BOOL; stdcall;
TrueExtTextOutW:function(DC: HDC; X, Y: Integer; Options: Longint;
  Rect: PRect; Str: PWideChar; Count: Longint; Dx: PInteger): BOOL; stdcall;
TrueTabbedTextOutA:function(hDC: HDC; X, Y: Integer; lpString: PAnsiChar; nCount, nTabPositions: Integer;
  var lpnTabStopPositions; nTabOrigin: Integer): Longint; stdcall;
TrueTabbedTextOutW:function(hDC: HDC; X, Y: Integer; lpString: PWideChar; nCount, nTabPositions: Integer;
  var lpnTabStopPositions; nTabOrigin: Integer): Longint; stdcall;

Modifying:boolean=false;
Function MyBeginPaint(hWnd: HWND; var lpPaint: TPaintStruct): HDC; stdcall;
var pt:TPoint;
begin
result:=TrueBeginPaint(hwnd, lppaint);
getdcorgex(result, pt);
ClearStorageInRect(lppaint.rcPaint.Left + pt.X, lppaint.rcPaint.Top + pt.Y,
lppaint.rcPaint.Right + pt.X, lppaint.rcPaint.Bottom + pt.Y);
end;

function MyTextOutA(DC: HDC; X, Y: Integer; Str: PAnsiChar; Count: Integer): BOOL; stdcall;
var
p:TPoint;
s:TSize;
begin
getdcorgex(dc, p);
{$ifdef debug}
log('TextOutA');
{$endif}
GetTextExtentPoint32A(dc, str, count, s);
storagetext(str, p.X + x, p.Y + y, p.X + x + s.cx, p.Y + y + s.cy, WindowFromDC(dc));
if modifying then begin
modifying:=false;
result:=true;
exit;
end;
result :=TrueTextOutA(DC, X, Y, Str, count);
end;

function MyTextOutW(DC: HDC; X, Y: Integer; Str: PWideChar; Count: Integer): BOOL; stdcall;
var
p:TPoint;
s:TSize;
begin
getdcorgex(dc, p);
{$ifdef debug}
log('TextOutW');
{$endif}
GetTextExtentPoint32W(dc, str, count, s);
storagetext(str, p.X + x, p.Y + y, p.X + x + s.cx, p.Y + y + s.cy, WindowFromDC(dc));
if modifying then begin
modifying:=false;
result:=true;
exit;
end;
result :=TrueTextOutW(DC, X, Y, Str, count);
end;

function MyExtTextOutA(DC: HDC; X, Y: Integer; Options: Longint;
  Rect: PRect; Str: PAnsiChar; Count: Longint; Dx: PInteger): BOOL; stdcall;
var
p:TPoint;
s:TSize;
begin
getdcorgex(dc, p);
{$ifdef debug}
log('ExtTextOutA');
{$endif}
if rect <> nil then begin
Modifying:=true;
drawtextA(dc, str, count, rect^, dt_modifystring or dt_end_ellipsis or dt_path_ellipsis or dt_wordbreak);
if modifying then begin
storagetext(str, p.X + rect.Left, p.Y + rect.Top, p.X + rect.Right, p.Y + rect.Bottom, WindowFromDC(dc));
                       modifying:=false;
end;
end else begin
GetTextExtentPoint32A(dc, str, count, s);
storagetext(str, x + p.X, y + p.Y, x + p.X + s.cx, y + p.Y + s.cy, WindowFromDC(dc));
end;
result :=TrueExtTextOutA(DC, X, Y, Options, Rect, Str, count, dx);
end;

function MyExtTextOutW(DC: HDC; X, Y: Integer; Options: Longint;
  Rect: PRect; Str: PWideChar; Count: Longint; Dx: PInteger): BOOL; stdcall;
var
p:TPoint;
s:TSize;
begin
getdcorgex(dc, p);
{$ifdef debug}
log('ExtTextOutW');
{$endif}
{if (options and eto_opaque) = eto_opaque then
ClearStorageInRect(p.X + rect.Left, p.Y + rect.Top, p.X + rect.Right, p.Y + rect.Bottom)
else begin}
if rect <> nil then begin
Modifying:=true;
drawtextW(dc, str, count, rect^, dt_modifystring or dt_end_ellipsis or dt_path_ellipsis or dt_wordbreak);
if modifying then begin
storagetext(str, p.X + rect.Left, p.Y + rect.Top, p.X + rect.Right, p.Y + rect.Bottom, WindowFromDC(dc));
                       modifying:=false;
end;
end else begin
GetTextExtentPoint32W(dc, str, count, s);
storagetext(str, x + p.X, y + p.Y, x + p.X + s.cx, y + p.Y + s.cy, WindowFromDC(dc));
end;
result :=TrueExtTextOutW(DC, x, y, options, rect, str, count, dx);
end;

function MyTabbedTextOutA(hDC: HDC; X, Y: Integer; lpString: PAnsiChar; nCount, nTabPositions: Integer;
  var lpnTabStopPositions; nTabOrigin: Integer): Longint; stdcall;
var
p:TPoint;
s:TSize;
begin
getdcorgex(hdc, p);
{$ifdef debug}
log('TabbedTextOutA');
{$endif}
GetTextExtentPoint32A(hdc, lpstring, ncount, s);
storagetext(lpstring, p.X + x, p.Y + y, p.X + x + s.cx, p.Y + y + s.cy, WindowFromDC(hdc));
result :=TrueTabbedTextOutA(hdc, x, y, lpstring, ncount, ntabpositions, lpnTabStopPositions, ntaborigin);
end;

function MyTabbedTextOutW(hDC: HDC; X, Y: Integer; lpString: PWideChar; nCount, nTabPositions: Integer;
  var lpnTabStopPositions; nTabOrigin: Integer): Longint; stdcall;
var
p:TPoint;
s:TSize;
begin
getdcorgex(hdc, p);
{$ifdef debug}
log('TabbedTextOutW');
{$endif}
GetTextExtentPoint32W(hdc, lpstring, ncount, s);
storagetext(lpstring, p.X + x, p.Y + y, p.X + x + s.cx, p.Y + y + s.cy, WindowFromDC(hdc));
result :=TrueTabbedTextOutW(hdc, x, y, lpstring, ncount, ntabpositions, lpnTabStopPositions, ntaborigin);
end;
    Function HookFunctions:boolean;
    begin
result:=true;
GenerateInstructionsSizeArray;
if not (SetFunctionHook(user32, 'BeginPaint', @MyBeginPaint, @TrueBeginPaint) and
SetFunctionHook(gdi32, 'ExtTextOutA', @MyExtTextOutA, @TrueExtTextOutA) and
SetFunctionHook(gdi32, 'ExtTextOutW', @MyExtTextOutW, @TrueExtTextOutW) and
SetFunctionHook(gdi32, 'TextOutA', @MyTextOutA, @TrueTextOutA) and
SetFunctionHook(gdi32, 'TextOutW', @MyTextOutW, @TrueTextOutW) and
SetFunctionHook(user32, 'TabbedTextOutA', @MyTabbedTextOutA, @TrueTabbedTextOutA) and
SetFunctionHook(user32, 'TabbedTextOutW', @MyTabbedTextOutW, @TrueTabbedTextOutW)) then result:=false;
    end;

    Procedure UnhookFunctions;
begin
UnHookCode(@TrueBeginPaint);
   UnHookCode(@TrueTextOutA);
   UnHookCode(@TrueTextOutW);
   UnHookCode(@TrueExtTextOutA);
   UnHookCode(@TrueExtTextOutW);
  UnHookCode(@TrueTabbedTextOutA);
  UnHookCode(@TrueTabbedTextOutW);
   end;
end.
