unit logging;

interface
Procedure StartLog(fn:string);
procedure Log(str:string);
function SysErrorMessage(ErrorCode: Integer): string;
implementation
uses windows;
Function FileExists(const FileName:string):boolean;
var Handle:THandle;
    FindData: TWin32FindData;
begin
                               Handle := FindFirstFile(PChar(FileName), FindData);
  if Handle <> INVALID_HANDLE_VALUE then
  begin
    Windows.FindClose(Handle);
    if (FindData.dwFileAttributes and FILE_ATTRIBUTE_DIRECTORY) = 0 then
result:=true;
exit;
  end;
  Result := false;
end;

function SysErrorMessage(ErrorCode: Integer): string;
var
  Buffer: array[0..255] of Char;
var
  Len: Integer;
begin
  Len := FormatMessage(FORMAT_MESSAGE_FROM_SYSTEM or FORMAT_MESSAGE_IGNORE_INSERTS or
    FORMAT_MESSAGE_ARGUMENT_ARRAY, nil, ErrorCode, 0, Buffer,
    SizeOf(Buffer), nil);
  while (Len > 0) and (Buffer[Len - 1] in [#0..#32, '.']) do Dec(Len);
  SetString(Result, Buffer, Len);
end;

var logfile:string;
Procedure StartLog(fn:string);
var f:textfile;
begin
logfile:=fn;
assignfile(f, logfile);
if fileexists(logfile) then append(f) else  rewrite(f);
closefile(f);
end;

procedure Log(str:string);
var f:textfile;
begin
{$I-}
assignfile(f, logfile);
append(f);
writeln(f,str);
closefile(f);
end;
end.
